/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024  Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

//NPM Imports
const {validationResult, matchedData} = require('express-validator');

//local imports
const {userModel} = require('../../../schemas/userSchema');
const userBanModel = require('../../../schemas/userBanSchema');
const {exceptionHandler, errorHandler} = require('../../../utils/loggerUtils');

module.exports.post = async function(req, res){
    try{
        const validResult = validationResult(req);

        if(validResult.isEmpty()){
            const user = matchedData(req);

            //Would prefer to stick this in userModel.statics.register() but we end up with circular dependencies >:(
            const nukedBans = await userBanModel.checkProcessedBans(user.user);

            //if we found any related nuked bans
            if(nukedBans != null){
                //Shit our pants!
                return errorHandler(res, 'Cannon re-create banned account!', 'unauthorized');
            }

            await userModel.register(user)
            return res.sendStatus(200);
        }else{
            res.status(400);
            res.send({errors: validResult.array()})
        }
    }catch(err){
        exceptionHandler(res, err);
    }
}